<template>
  <transition name="fade">
    <div v-if="isVisible" class="modal">
      <header class="modal__header">
        <div class="modal__header-icon"></div>
        <div class="modal__header-content">
          <div class="modal__header-title">{{ $t("title") }}</div>
          <div class="modal__header-subtitle">{{ $t("subtitle") }}</div>
        </div>
        <button
          :disabled="isBtnDisabled"
          @click.prevent="close"
          href="#"
          class="modal-close"
        ></button>
      </header>
      <main class="main">
        <transition name="fade_delivery_empty">
          <div v-if="isEmpty" class="empty">{{ $t("empty") }}</div>
        </transition>
        <transition name="fade_delivery">
          <div v-if="!isEmpty" class="delivery">
            <div class="delivery-item delivery__avaible">
              <div class="delivery__avaible-weight">{{ weight }} {{ $t("weight") }}.</div>
              <div class="delivery__avaible__image">
                <img style="" src="img/box.svg" alt="" />
              </div>
              <div class="delivery__avaible-quantity">{{ count }} {{ $t("count") }}.</div>
            </div>
            <div class="delivery-arrow">
              <span :class="sumbitProcess ? 'loading' : ''"></span>
            </div>
            <div class="delivery-item delivery__receiving">
              <div class="delivery__receiving-experience">
                {{ cost_exp }} оп.
              </div>
              <div class="delivery__receiving-money">${{ cost_soft }}</div>
            </div>
          </div>
        </transition>
        <div class="actions">
          <transition name="fade_delivery">
            <button
              :disabled="isBtnDisabled"
              v-if="!isEmpty"
              @click.prevent="sumbit"
              @mouseover="(e) => customMouseEvent(e, 'accept', 'isHover')"
              @mouseleave="customMouseEvent"
              @mousedown="(e) => customMouseEvent(e, 'accept', 'isPressed')"
              @mouseup="customMouseEvent"
              :class="[{ hover: accept.isHover }, { focus: accept.isPressed }]"
              href="#"
              id="accept"
              class="actions-btn actions-btn_accept"
            >
              Сдать улики
            </button>
          </transition>
          <button
            :disabled="isBtnDisabled"
            @click.prevent="close"
            @mouseover="(e) => customMouseEvent(e, 'deny', 'isHover')"
            @mouseleave="customMouseEvent"
            @mousedown="(e) => customMouseEvent(e, 'deny', 'isPressed')"
            @mouseup="customMouseEvent"
            :class="[{ hover: deny.isHover }, { focus: deny.isPressed }]"
            href="#"
            class="actions-btn actions-btn_deny"
          >
            Закрыть
          </button>
        </div>
      </main>
    </div>
  </transition>
</template>

<script>
import { bus } from "../main";

export default {
  name: "EvidenceTransfer",
  data() {
    return {
      localData: {

      },
      accept: {
        isHover: false,
        isPressed: false,
      },
      deny: {
        isHover: false,
        isPressed: false,
      },
      sumbitProcess: false,
      isBtnDisabled: false,
      isEmpty: false,
      isVisible: false
    };
  },
  methods: {
    close() {
      // mp.trigger( "UI.PoliceEvidence.Close" )
    },
    sumbit() {
      this.sumbitProcess = true;
      this.isBtnDisabled = true;
      setTimeout(() => {
        this.isEmpty = true;
        this.isBtnDisabled = false;
        // mp.trigger( "UI.PoliceEvidence.HandOver" )
      }, 1000);
    },
    allStylingRemove() {
      this.accept = {
        isHover: false,
        isPressed: false,
      };
      this.deny = {
        isHover: false,
        isPressed: false,
        isDisabled: false,
      };
    },
    customMouseEvent(event = null, isStyling = null, value = null) {
      if (event.type == "mouseover" || event.type == "mousedown") {
        this.allStylingRemove();
        let newObj = {
          [value]: true,
        };
        this[isStyling] = newObj;
      } else {
        this.allStylingRemove();
      }
    },
    startArrowAnimation() {},
  },
  computed: {
    count() {
      return this.localData.count;
    },
    weight() {
      return this.localData.count * this.localData.weight;
    },
    cost_exp() {
      return this.localData.count * this.localData.cost_exp;
    },
    cost_soft() {
      return this.localData.count * this.localData.cost_soft;
    },
  },
  created() {
    bus.$on('show', (data) => {
      this.localData = data;
      this.isVisible = true;
    })
  }
};
</script>

<style>
@import "~@/assets/styles/evidence.css";
</style>